/*
 * JBoss, Home of Professional Open Source
 * Copyright 2009, Red Hat Middleware LLC, and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.jboss.test.managed.factory.support.defaults;

import org.jboss.metatype.api.types.MetaType;
import org.jboss.metatype.api.types.PropertiesMetaType;
import org.jboss.metatype.api.values.MetaValue;
import org.jboss.metatype.api.values.PropertiesMetaValue;
import org.jboss.metatype.spi.values.DefaultValueBuilder;

/**
 * A custom DefaultValueBuilder that parses key/value pairs based on a ';' separator
 * @author Scott.Stark@jboss.org
 * @version $Revision:$
 */
public class CustomPropsBuilder
   implements DefaultValueBuilder
{

   public MetaValue buildMetaValue(String value) throws Exception
   {
      PropertiesMetaValue metaValue = new PropertiesMetaValue();
      String[] pairs = value.split(";");
      for(int n = 0; n < pairs.length; n ++)
      {
         String[] kv = pairs[n].split("=");
         metaValue.put(kv[0], kv[1]);
      }
      return metaValue;
   }

   public MetaType getType()
   {
      return PropertiesMetaType.INSTANCE;
   }

}
